

  /* SCREEN DISPLAY PROCESS PROGRAMS */
void  cursoroff()
  {
   setcursor(15,0);
  }

  /* cursor display process */
void  cursoron()
  {
   if (monochrome==ON) setcursor(12,13);
   else setcursor(6,7);
  }

  /* set cursor shape */
setcursor(int str,int stp)
  {
   union REGS reg;
   reg.h.ah=1;
   reg.x.cx=(str<<8)+stp;
   int86(0x10,&reg,&reg);
  }

  /* draw test picture */
void  drawscreen()
  {
   int yy;
   char gtable[20][25];

   setback(CYAN);
   clrscr();
   setcolor(YELLOW);
   gotoxy(1,1);
   cputs("PCLS-TEST VER 5.0         TEST PROGRAM FOR PC-LabCards           ADVANTECH 1995");
   setcolor(BROWN);
   gotoxy(1,2);
   cputs("\n");
   setcolor(WHITE);
   gotoxy(1,3);
   cputs("  Cardtype    Address     IRQ level   A/D range   D/A range   Edit     HELP\0");
   setcolor(BROWN);
   gotoxy(1,4);
   cputs("\n");
   setcolor(YELLOW);

   strcpy(gtable[0], " Analog-Digital ");
   strcpy(gtable[1], "  0             ");
   strcpy(gtable[2], "  1             ");
   strcpy(gtable[3], "  2             ");
   strcpy(gtable[4], "  3             ");
   strcpy(gtable[5], "  4             ");
   strcpy(gtable[6], "  5             ");
   strcpy(gtable[7], "  6             ");
   strcpy(gtable[8], "  7             ");
   strcpy(gtable[9], "  8             ");
   strcpy(gtable[10],"  9             ");
   strcpy(gtable[11]," 10             ");
   strcpy(gtable[12]," 11             ");
   strcpy(gtable[13]," 12             ");
   strcpy(gtable[14]," 13             ");
   strcpy(gtable[15]," 14             ");
   strcpy(gtable[16]," 15             ");
   strcpy(gtable[17],"");
   setinverse(MAGENTA);
   for (yy=0;yy<=17;yy++) {
         gotoxy(2,yy+5);
         cputs(gtable[yy]);
                }
   if (boardI==PCL813B) {
		strcpy(gtable[0], " Analog-Digital ");
    strcpy(gtable[1], " 16             ");
    strcpy(gtable[2], " 17             ");
    strcpy(gtable[3], " 18             ");
    strcpy(gtable[4], " 19             ");
    strcpy(gtable[5], " 20             ");
    strcpy(gtable[6], " 21             ");
    strcpy(gtable[7], " 22             ");
    strcpy(gtable[8], " 23             ");
    strcpy(gtable[9], " 24             ");
	strcpy(gtable[10]," 25             ");
    strcpy(gtable[11]," 26             ");
	strcpy(gtable[12]," 27             ");
	strcpy(gtable[13]," 28             ");
	strcpy(gtable[14]," 29             ");
	strcpy(gtable[15]," 30             ");
	strcpy(gtable[16]," 31             ");
    strcpy(gtable[17],"");

      setinverse(MAGENTA);
	  for (yy=0;yy<=17;yy++) {
           gotoxy(22,yy+5);
           cputs(gtable[yy]);
      }
   }
   else {
   strcpy(gtable[0],  " Digital-Analog ");
   strcpy(gtable[1],  "  0             ");
   strcpy(gtable[2],  "  1             ");
   strcpy(gtable[3],  "  2             ");
   strcpy(gtable[4],  "  3             ");
   strcpy(gtable[5],  "  4             ");
   strcpy(gtable[6],  "  5             ");
   strcpy(gtable[7],  "  6             ");
   strcpy(gtable[8],  "  7             ");
   strcpy(gtable[9],  "  8             ");
   strcpy(gtable[10], "  9             ");
   strcpy(gtable[11], " 10             ");
   strcpy(gtable[12], " 11             ");
   strcpy(gtable[13], "");

   setinverse(RED);
      for (yy=0;yy<=13;yy++) {
          gotoxy(22,yy+5);
          cputs(gtable[yy]);
	  }
   }
   strcpy(gtable[0], " Digital-IN Ŀ");
   strcpy(gtable[1], "  0      16     ");
   strcpy(gtable[2], "  1      17     ");
   strcpy(gtable[3], "  2      18     ");
   strcpy(gtable[4], "  3      19     ");
   strcpy(gtable[5], "  4      20     ");
   strcpy(gtable[6], "  5      21     ");
   strcpy(gtable[7], "  6      22     ");
   strcpy(gtable[8], "  7      23     ");
   strcpy(gtable[9], "  8      24     ");
   strcpy(gtable[10],"  9      25     ");
   strcpy(gtable[11]," 10      26     ");
   strcpy(gtable[12]," 11      27     ");
   strcpy(gtable[13]," 12      28     ");
   strcpy(gtable[14]," 13      29     ");
   strcpy(gtable[15]," 14      30     ");
   strcpy(gtable[16]," 15      31     ");
   strcpy(gtable[17],"");
   setinverse(GREEN);
   for (yy=0;yy<=17;yy++) {
     gotoxy(42,yy+5);
     cputs(gtable[yy]);
   }
   strcpy(gtable[0], " Digital-OUT Ŀ");
   strcpy(gtable[1], "  0      16     ");
   strcpy(gtable[2], "  1      17     ");
   strcpy(gtable[3], "  2      18     ");
   strcpy(gtable[4], "  3      19     ");
   strcpy(gtable[5], "  4      20     ");
   strcpy(gtable[6], "  5      21     ");
   strcpy(gtable[7], "  6      22     ");
   strcpy(gtable[8], "  7      23     ");
   strcpy(gtable[9], "  8      24     ");
   strcpy(gtable[10],"  9      25     ");
   strcpy(gtable[11]," 10      26     ");
   strcpy(gtable[12]," 11      27     ");
   strcpy(gtable[13]," 12      28     ");
   strcpy(gtable[14]," 13      29     ");
   strcpy(gtable[15]," 14      30     ");
   strcpy(gtable[16]," 15      31     ");
   strcpy(gtable[17],"");
   setinverse(BLUE);
   for (yy=0;yy<=17;yy++) {
         gotoxy(62,yy+5);
         cputs(gtable[yy]);
   }
  }

  /* clear display area */
void  clearfield()
  {
   int yy;
  /* clear A/D screen */
                setinverse(MAGENTA);
        for (yy=0;yy<16;yy++) {
          gotoxy(ADLINE,yy+6);
          cputs("           ");
        }
  /* clear D/A screen */
		setinverse(RED);
        for (yy=0;yy<12;yy++) {
          gotoxy(DALINE,yy+6);
          cputs("         ");
        }
  /* clear DI screen */
        setinverse(GREEN);
        for (yy=0;yy<16;yy++) {
                  gotoxy(DILINE1,yy+6);
		  cputs(" ");
          gotoxy(DILINE2,yy+6);
          cputs(" ");
          gotoxy(DILINE1-4,yy+6);
          cputs(" ");
          gotoxy(DILINE2-4,yy+6);
				  cputs(" ");
		}
  /* clear DO screen */
    setinverse(BLUE);
    for (yy=0;yy<16;yy++) {
          gotoxy(DOLINE1,yy+6);
          cputs(" ");
          gotoxy(DOLINE2,yy+6);
          cputs(" ");
        }
  }


  /* display D/A value */
void  show_DA(vch)
  int vch;
  {
   int indx;
   int va_f;

   if (((boardI==PCL726)&&(da_gain[0]==4))||((boardI==PCL728)&&(da_gain[0]>=4))||((boardI==PCL727)&&(da_gain[0]==3)))
          va_f=ON;
   else va_f=OFF;
   setinverse(RED);
   for (indx=0;indx<da_no;indx++) {
         gotoxy(DALINE,6+indx);
         if (indx==vch) setnormal(MAGENTA);
         if (va_f==ON) cprintf("%6.2f mA",da_value[indx]);
                 else cprintf("%6.2f  V",da_value[indx]);
				 setinverse(RED);
   }
  }

  /* display A/D value */
void  show_AD()
  {
   int indx;
   int point;

   setinverse(MAGENTA);
   switch (boardI) {
         case PCL711B:
         case PCL818:
     case PCL818H:
     case PCL818HD:
     case PCL818L:
                 case PCL812PG:
                 case PCL1800:
                  if (vc_f==ON) {
                        for (indx=0;indx<ad_no;indx++) {
                          gotoxy(ADLINE,6+indx);
                          cprintf("%8.4f V" ,ad_value[indx]);
                        }
                  }
				  else {
                        for (indx=0;indx<ad_no;indx++) {
                          gotoxy(ADLINE,6+indx);
                                                  cprintf("   %04.0f   " ,ad_value[indx]);
                                                }
                                  }
                                  setnormal(CYAN);
                                  break;
                 case PCL818HG:
                 case MIC2718:
                                  if (vc_f==ON) {

                          for (indx=0;indx<ad_no;indx++) {
                                                                  gotoxy(ADLINE,6+indx);
                                                                  if (mvc_f[indx]==OFF)
                                  cprintf("%8.4f V" ,ad_value[indx]);
				  else
								  cprintf("%7.2f mV" ,ad_value[indx]);
                 }
              }
                  else {
            for (indx=0;indx<ad_no;indx++) {
              gotoxy(ADLINE,6+indx);
              cprintf("   %04.0f   " ,ad_value[indx]);
            }
          }
          setnormal(CYAN);
                  break;
                 case PCL813B:

                  if (vc_f==ON) {
            for (indx=0;indx<16;indx++) {
              gotoxy(ADLINE,6+indx);
              cprintf("%8.4f V" ,ad_value[indx]);
                          gotoxy(DALINE,6+indx);
              cprintf("%8.4f V" ,ad_value[indx+16]);
			  }

          }
                  else {
            for (indx=0;indx<16;indx++) {
                          gotoxy(ADLINE,6+indx);
              cprintf("   %04.0f   " ,ad_value[indx]);
                          gotoxy(DALINE,6+indx);
                          cprintf("   %04.0f   " ,ad_value[indx+16]);
                                                }
		  }
          setnormal(CYAN);
                  break;
         case PCL860:
		  indx=0;
          point=ad_range%4;
				  gotoxy(ADLINE,6+indx);
                  if (vc_f==ON) {
            switch (point) {
              case 0:
                   cprintf("%07.2f  V",ad_value[indx]);
                   break;
              case 1:
                   cprintf("%07.3f  V",ad_value[indx]);
                   break;
                          case 2:
                                                                   cprintf("%07.4f  V",ad_value[indx]);
                   break;
              case 3:
                   cprintf("%07.2f mV",ad_value[indx]);
                   break;
              default:
                   break;
            }
                  }
		  else cprintf("  %06.0f  ",ad_value[indx]);
          setnormal(CYAN);
                  break;
   }
  }

  /* display D/I status */
void  show_DI()
  {
   int indx;
   int byteno;
   int bitno;
   int bitcnt;

   setinverse(GREEN);
   for (indx=0;indx<di_no;indx++) {
		 if (indx>=16) gotoxy(DILINE2,6+(indx%16));
         else gotoxy(DILINE1,6+indx);
         cprintf("%c",di_value[indx]);
   }
   if (iflag==ON)
   {
          for (indx=0;indx<di_no;indx++) {
				 byteno=indx/8;
				 bitno=indx%8;
				 bitcnt=1;
				 bitcnt<<=bitno;
				 if ((int_status[byteno]&bitcnt)==0) int_value[indx]=' ';
				 else if(boardI==PCL730) {
						if(indx==0||indx==1||indx==16||indx==17)
						int_value[indx]='*'; }
				 else int_value[indx]='*';

		  }
		  for (indx=0;indx<di_no;indx++) {
				if (indx>=16) gotoxy(DILINE2-4,6+(indx%16));
				else gotoxy(DILINE1-4,6+indx);
				cprintf("%c",int_value[indx]);
		  }
//          printf("\7");
		  iflag=OFF;
   }
   for (indx=0;indx<di_no;indx++) {
				if (indx>=16) gotoxy(DILINE2-4,6+(indx%16));
				else gotoxy(DILINE1-4,6+indx);
				cprintf(" ");
		  }


   setnormal(CYAN);
  }

  /* display D/O status */
void  show_DO(vch)
  int vch;
  {
   int indx;
                setinverse(BLUE);
				for (indx=0;indx<do_no;indx++) {
                  if (indx>=16) gotoxy(DOLINE2,6+indx%16);
                  else gotoxy(DOLINE1,6+indx);
                  if (indx==vch) setnormal(MAGENTA);
                  cprintf("%c",do_value[indx]);
                  setinverse(BLUE);
                }
  }

  /* display help ,hints messages */
void  showhelp(no)
  int no;
  {
   setback(BLUE);
   setcolor(WHITE);
   switch(no) {
		 case KNULL:
		  /* if (( boardI==PCL813 )&&(ad_32==OFF))
		   {
		   gotoxy(1,24);
		   delline();
		   gotoxy(1,24);
				   cputs("LEFT/RIGHT ARROW-menu select          ENTER-confirm           F10-exit to DOS    ");
		   gotoxy(1,25);
		   delline();
		   gotoxy(1,25);
		   cputs("F1-toggle voltage/count display   F2-channel 16 to 32    '*'-interrupt mark  ");
		   }
		   else if (( boardI==PCL813)&&(ad_32==ON))
		   {
		   gotoxy(1,24);
		   delline();
				   gotoxy(1,24);
		   cputs("LEFT/RIGHT ARROW-menu select          ENTER-confirm           F10-exit to DOS    ");
				   gotoxy(1,25);
		   delline();
		   gotoxy(1,25);
		   cputs("F1-toggle voltage/count display   F2-channel 1 to 16     '*'-interrupt mark  ");
		   }

		   else */

		   gotoxy(1,24);
		   delline();
		   gotoxy(1,24);
				   cputs("LEFT/RIGHT ARROW-menu select          ENTER-confirm           F10-exit to DOS    ");
				   gotoxy(1,25);
				   delline();
				   gotoxy(1,25);
				   cputs("F1-toggle voltage/count display                           '*'-interrupt mark ");
				   break;
		 case CARDTYPE:
		 case ADDRESS:
		 case IRQ_LEVEL:
		 case AD_RANGE:
		 case DA_RANGE:
		 case EDIT:
		 case ADDorS:
		 case ADSET:
				   gotoxy(1,24);
				   delline();
				   gotoxy(1,24);
				   cputs("LEFT/RIGHT ARROW-menu select     UP/DOWN ARROW-item select     ENTER-confirm ");
				   gotoxy(1,25);
				   delline();
				   gotoxy(1,25);
				   cputs("ESC-exit without change                                   '*'-interrupt mark ");
				   break;
		 case INDIVIDUAL:
				   gotoxy(1,24);
				   delline();
				   gotoxy(1,24);
				   cputs("LEFT/RIGHT ARROW-menu select     UP/DOWN ARROW-item select     ENTER-confirm ");
				   gotoxy(1,25);
				   delline();
				   gotoxy(1,25);
				   cputs("PGUP/PGDN-range select           ESC-exit without change                     ");
				   break;
		 case DAEDIT:
				   gotoxy(1,24);
				   delline();
				   gotoxy(1,24);
				   cputs("UP/DOWN ARROW-channel select        LEFT/RIGHT ARROW-inc./dec. 0.1 step      ");
				   gotoxy(1,25);
				   delline();
				   gotoxy(1,25);
				   cputs("PGUP/PGDN-inc./dec. 0.01 step       ESC-exit              '*'-interrupt mark ");
				   break;
		 case DOEDIT:
				   gotoxy(1,24);
				   delline();
				   gotoxy(1,24);
				   cputs("UP/DOWN ARROW-channel select        RIGHT/LEFT ARROW-change ON/OFF status    ");
				   gotoxy(1,25);
				   delline();
				   gotoxy(1,25);
				   cputs("ESC-exit                                                  '*'-interrupt mark ");
				   break;
/*		 case HELP:
						gotoxy(1,24);
						delline();
						gotoxy(1,24);
						cputs("LEFT/RIGHT ARROW-menu select          ENTER-confirm           F10-exit to DOS    ");
						gotoxy(1,25);
						delline();
						break; */

		 default:
				   break;
   }
  }


  /* display menu */
void  showmenu(no)
  int no;
  {

   int indx;
   struct menutable{              /* menu function screen table */
				   char name[10];         /* menu function name */
				   int xpos;              /* menu function location */
				   int ypos;
				 }menufun[TOTALMENU]={
   {"Cardtype\0",3,3},{"Address\0",15,3},{"IRQ level\0",27,3},{"A/D range\0",39,3},{"D/A range\0",51,3},{"Edit\0",63,3},{"HELP",72,3}};
   setcolor(YELLOW);
   setnormal(CYAN);
   for (indx=0;indx<TOTALMENU;indx++) {
								if((irqI==NOONE&&indx==IRQ_LEVEL)||(ad_range_no==NOONE&&indx==AD_RANGE)||
								   (da_range_no==NOONE&&indx==DA_RANGE)||(da_no==NOONE&&do_no==NOONE&&indx==EDIT))
								 setcolor(BLACK);
								 else
								 setcolor(YELLOW);

		 if (indx==no) setinverse(MAGENTA);
         gotoxy(menufun[indx].xpos,menufun[indx].ypos);
                 cputs(menufun[indx].name);
         setnormal(CYAN);
   }
   setcolor(WHITE);
  }

  /* display items */
void  showitem(menutype,itemno)
  int menutype;
  int itemno;
  {
   int indx;
   static int left,right,center,peritem;
   char *help_str[22]={
 {"                    * * *   WELCOME TO PCLS-TEST  * * *                 "},
 {" "},
 {" This is a self-test program for user to check the basic functions of the "},
 {" PCL-CARDS ( PCL-711B, 720, 725, 726, 727, 728, 730, 732, 812PG, 813B, 818"},
 {" series,860 and 1800 ) under a single interactive display page. "},
 {" "},
 {" The menu bar functions contain :     1)Cardtype  - Select card type. "},
 {"   2)Address   - Base address.        3)IRQ level - Card's IRQ level.  "},
 {"   4)A/D range - Analog input range.  5)D/A range - Analog output range."},
 {"   6)Edit      - D/O or D/A edit.     7)HELP      - Show this screen. "},
 {""},
 {" In menu bar : "},
 {"   [RIGHT] / [LEFT] Arrow - Select hardware configuration.  "},
 {"   [RETURN] / [ENTER]     - Execute your selection. "},
 {" "},
 {" In 'Edit' mode : "},
 {"   [RIGHT]/[LEFT]/[UP]/[DOWN] Arrow - Move cursor or edit it."},
 {" "},
 {" MACRO Keys : "},
 {"   F1  - Toggle voltage/count display. "},
 {"   ESC - Return upper lever."},
 {"   F10 - Exit this program."}};

   char card_str[TOTALCARD][11]={
   {" PCL711B  \0"},
   {" PCL720   \0"},
   {" PCL725   \0"},
   {" PCL726   \0"},
   {" PCL727   \0"},
   {" PCL728   \0"},
   {" PCL730   \0"},
   {" PCL732   \0"},
   {" PCL812PG \0"},
   {" PCL813B  \0"},
   {" PCL818   \0"},
   {" PCL818H  \0"},
   {" PCL818HD \0"},
   {" PCL818HG \0"},
   {" PCL818L  \0"},
   {" PCL860   \0"},
   {" PCL1800  \0"},
   {" MIC2718  \0"}

   };

   char *ad_str[TOTALCARD][15]={
   {{"-5V      to      5V\0"},{"-2.5V    to    2.5V\0"},{"-1.25V   to   1.25V\0"},{"-0.625V  to  0.625V\0"},{"-0.3125V to 0.3125V\0"}},
   {{" "}},
   {{" "}},
   {{" "}},
   {{" "}},
   {{" "}},
   {{" "}},
   {{" "}},
   {{"-5V      to      5V\0"},{"-2.5V    to    2.5V\0"},{"-1.25V   to   1.25V\0"},{"-0.625V  to  0.625V\0"},{"-0.3125V to 0.3125V\0"}},
   {{"-5V      to      5V\0"},{"-2.5V    to    2.5V\0"},{"-1.25V   to   1.25V\0"},{"-0.625V  to  0.625V\0"},{"0V       to      5V\0"},{"0V       to    2.5V\0"},{"0V       to   1.25V\0"},{"0V       to  0.625V\0"}},
   {{"-5V      to      5V\0"},{"-2.5V    to    2.5V\0"},{"-1V      to      1V\0"},{"-0.5V    to    0.5V\0"},{"0V       to     10V\0"},{"0V       to      5V\0"},{"0V       to      2V\0"},{"0V       to      1V\0"},{"-10V     to     10V\0"}},
   {{"-5V      to      5V\0"},{"-2.5V    to    2.5V\0"},{"-1.25V   to   1.25V\0"},{"-0.625V  to  0.625V\0"},{"0V       to     10V\0"},{"0V       to      5V\0"},{"0V       to    2.5V\0"},{"0V       to   1.25V\0"},{"-10V     to     10V\0"}},
   {{"-5V      to      5V\0"},{"-2.5V    to    2.5V\0"},{"-1.25V   to   1.25V\0"},{"-0.625V  to  0.625V\0"},{"0V       to     10V\0"},{"0V       to      5V\0"},{"0V       to    2.5V\0"},{"0V       to   1.25V\0"},{"-10V     to     10V\0"}},
   {{"-5V      to      5V\0"},{"-0.5V    to    0.5V\0"},{"-0.05V   to   0.05V\0"},{"-0.005V  to  0.005V\0"},{"0V       to     10V\0"},{"0V       to      1V\0"},{"0V       to    0.1V\0"},{"0V       to   0.01V\0"},{"-10V     to     10V\0"},{"-1V      to      1V\0"},{"-0.1V    to    0.1V\0"},{"-0.01V   to   0.01V\0"}},
   {{"-5V      to      5V\0"},{"-2.5V    to    2.5V\0"},{"-1.25V   to   1.25V\0"},{"-0.625V  to  0.625V\0"}},
   {{" DC :    +/- 200V  \0"},{" DC :    +/-  20V  \0"},{" DC :    +/-   2V  \0"},{" DC :    +/- 0.2V  \0"},{" AC :        200V  \0"},{" AC :         20V  \0"},{" AC :          2V  \0"},{" AC :        0.2V  \0"}},
   {{"-5V      to      5V\0"},{"-2.5V    to    2.5V\0"},{"-1.25V   to   1.25V\0"},{"-0.625V  to  0.625V\0"},{"0V       to     10V\0"},{"0V       to      5V\0"},{"0V       to    2.5V\0"},{"0V       to   1.25V\0"},{"-10V     to     10V\0"}},
   {{"-5V      to      5V\0"},{"-0.5V    to    0.5V\0"},{"-0.05V   to   0.05V\0"},{"-0.005V  to  0.005V\0"},{"0V       to     10V\0"},{"0V       to      1V\0"},{"0V       to    0.1V\0"},{"0V       to   0.01V\0"},{"-10V     to     10V\0"},{"-1V      to      1V\0"},{"-0.1V    to    0.1V\0"},{"-0.01V   to   0.01V\0"}}
   };

   char *da_str[TOTALCARD][6]={
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}},
   {{" "}},
   {{" "}},

   {{" 0V      to     5V \0"},{" 0V      to    10V \0"},{" -5V     to     5V \0"},{" -10V    to    10V \0"},{" 4mA     to   20mA \0"}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"},{" -5V     to     5V \0"},{" 4mA     to   20mA \0"}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"},{" -5V     to     5V \0"},{" -10V    to    10V \0"},{" 4mA     to   20mA \0"},{" 0mA     to   20mA \0"}},
   {{" "}},
   {{" "}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}},
   {{" "}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}},
   {{"        0.1 mA     \0"},{"          1 mA     \0"},{"         10 mA     \0"},{"   User Defined    \0"}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}},
   {{" 0V      to     5V \0"},{" 0V      to    10V \0"}}
   };

   char edit_str[2][14]={
   {" D/A editing \0"},{" D/O editing \0"}};

   char setting[2][13]={
   {" OVERALL    \0"},{" INDIVIDUAL \0"}};

   char admode[2][13]={
   {"SIGNLE-ENDED\0"},{"DIFFERENTIAL\0"}};

   int gain_code;

   setcolor(WHITE);
   switch (menutype) {

         case CARDTYPE:
                  for (indx=0;indx<TOTALCARD;indx++) {
						  gotoxy(2,2+indx);
                          if (indx==itemno) setinverse(MAGENTA);
                          cputs(card_str[indx]);
                                                  setnormal(BLUE);
          }
//          if(indx==TOTALCARD) indx=PCL818HG;
       break;

     case ADDRESS:
                  gotoxy(2,2);
          cputs(" Base Address : ");
				  setinverse(MAGENTA);
          cprintf("%3x",itemno);
          setnormal(BLUE);
                   break;
  
     case IRQ_LEVEL:
          gotoxy(2,2);
          if (irqI != 0) {
                                                                 cputs(" IRQ Level : ");
                 setinverse(MAGENTA);
																 cprintf("%1x",itemno);
                 setnormal(BLUE);
              }
       break;
  
     case AD_RANGE:
          if (ad_range_no>0) {
                         for (indx=0;indx<ad_range_no;indx++) {
                                         gotoxy(2,2+indx);
                     if (indx==itemno) setinverse(MAGENTA);
                                         cputs(ad_str[boardI][indx]);
                                         setnormal(BLUE);
                                                 }
          }
           break;

     case DA_RANGE:
                                  if (da_range_no>0) {
                         for (indx=0;indx<da_range_no;indx++) {
                     gotoxy(2,2+indx);
                                         if (indx==itemno) setinverse(MAGENTA);
                     cputs(da_str[boardI][indx]);
                                         setnormal(BLUE);
             }
                  }
	   break;
  

		 case EDIT:
          if ((da_no>0)||(do_no>0)) {
                 for (indx=0;indx<2;indx++) {
                      gotoxy(2,2+indx);
                                           if (indx==itemno) setinverse(MAGENTA);
                       cputs(edit_str[indx]);
                                           setnormal(BLUE);
						 }
          }
  
       break;

     case ADSET:
                  for (indx=0;indx<2;indx++) {
                          gotoxy(2,2+indx);
                          if (indx==itemno) setinverse(MAGENTA);
                          cputs(setting[indx]);
                          setnormal(BLUE);
                  }
           break;

     case INDIVIDUAL:

		   if (boardI!=PCL813B)
                   {
                                  for (indx=0;indx<ad_no;indx++) {
                          gain_code=ad_gain[indx];
						  gotoxy(2,2+indx);
						  cprintf("CH%02d: ",indx);
			  if (indx==itemno) setinverse(MAGENTA);
						  cputs(ad_str[boardI][gain_code]);
			  setnormal(BLUE);
		  }
		   }
		   else
		   {
		  if(itemno<=0){ left=0; right=16; center=itemno; }
		  else if(itemno==31){ left=16;right=32;center=15;}
				  else if(itemno>=left&&itemno<right)
				  {
						if(peritem<itemno)     {if((center++)>15)  center=15; }
						else if(peritem>itemno) { if((center--)<1) center=0;}
				  }
				  else if(peritem<itemno) { left++;  right++; if((center++)>=15) center=15;}
				  else if(peritem>itemno) { left--;  right--; if((center--)<=0) center=0; }

				  for (indx=left;indx<right;indx++) {
						  gain_code=ad_gain[indx];
												  gotoxy(2,2+indx-left);
						  cprintf("CH%02d: ",indx);
						  if ((indx-left)==center) setinverse(MAGENTA);
						  cputs(ad_str[boardI][gain_code]);
						  setnormal(BLUE);
				  }
		   }

		   peritem=itemno;
		   break;

		   case HELP:
								   for (indx=0;indx<22;indx++) {
												gotoxy(2,2+indx);
                                                 cputs(help_str[indx]);
                                   }
           break;


         case ADDorS:
                  if ((da_no>0)||(do_no>0)) {
                                 for (indx=0;indx<2;indx++) {
                                          gotoxy(2,2+indx);
                                                                                   if (indx==itemno) setinverse(MAGENTA);
                                           cputs(admode[indx]);
                                                                                   setnormal(BLUE);
                                                 }
                  }
          break;

         default:
                   break;
   }
  }

frame(left,top,right,bottom,fun)
  int left;
  int top;
  int right;
  int bottom;
  int fun;
  {
   int xx,yy;
   int length,width;
   int line;
   switch (fun) {
                 case SETUP:
                                gettext(left,top,right,bottom,vbuf);
                                window(left,top,right,bottom);
                                setback(BLUE);
                                clrscr();
                                length=bottom-top+1;
                                width=right-left+1;
                                for (xx=1;xx<=width;xx++)
                                   for (yy=1;yy<=length;yy++) {
                                          gotoxy(xx,yy);
                                          putch(' ');
                                   }
                                setcolor(YELLOW);
                                gotoxy(1,1);putch('');
                                gotoxy(width,1);putch('');
                                gotoxy(1,length-1);putch('');
                                gotoxy(width,length-1);putch('');
                gotoxy(1,length-1);insline();
				for (line=2;line<width;line++) {
                   gotoxy(line,1);putch('');
                                   gotoxy(line,length);putch('');
                }
                for (line=2;line<length;line++) {
                   gotoxy(1,line);putch('');
                                   gotoxy(width,line);putch('');
                }
                setcolor(WHITE);
                break;
      case RECOVER:
                                puttext(left,top,right,bottom,vbuf);
                window(1,1,80,25);
                break;
   }
  }
  
  /* set background color */
setback(color)
  int color;
  {
   if (monochrome==OFF) textbackground(color);
   else textbackground(BLACK);
  }

  /* set text color */
setcolor(color)
  int color;
  {
   if (monochrome==OFF) textcolor(color);
   else textcolor(WHITE);
  }

  /* set item background color to inverse */
setinverse(color)
  int color;
  {
   if (monochrome==ON) {textbackground(WHITE);textcolor(BLACK);}
   else textbackground(color);
  }

  /* set item background color to normal */
setnormal(color)
  int color;
  {
   if (monochrome==ON) {textbackground(BLACK);textcolor(WHITE);}
   else textbackground(color);
  }

void  winproc(menutype,opcode)
  int menutype;
  int opcode;
  {
   int cnt;
   setnormal(BLUE);
   switch (menutype) {
                 case CARDTYPE:
                        frame(2,4,13,TOTALCARD+5,opcode);
                        if (opcode==SETUP) showitem(CARDTYPE,boardI);
                                                break;
         case ADDRESS:
                                                frame(12,4,33,6,opcode);
                        if (opcode==SETUP) showitem(ADDRESS,baseI);
                        break;
                 case IRQ_LEVEL:
                                                frame(25,4,41,6,opcode);
                                                if (opcode==SETUP) showitem(IRQ_LEVEL,irqI);
                                                break;
                 case AD_RANGE:
                        if (ad_range_no>0) {
												   frame(39,4,59,ad_range_no+5,opcode);
                           if (opcode==SETUP) showitem(AD_RANGE,ad_range);
                        }
                                                break;
                 case DA_RANGE:
                        if (da_range_no>0) {
						   frame(52,4,72,da_range_no+5,opcode);
												   if (opcode==SETUP) showitem(DA_RANGE,da_range);
												}
						break;

		 case EDIT:
						if ((do_no>0)||(da_no>0)) {
						   frame(63,4,77,7,opcode);
						   if (opcode==SETUP) showitem(EDIT,0);
												}
						break;
		 case ADSET:
								frame(39,4,52,7,opcode);
								if (opcode==SETUP) showitem(ADSET,0);
						break;

		 case ADDorS:
				frame(39,4,52,7,opcode);
								if (opcode==SETUP) showitem(ADDorS,0);
												break;


		 case INDIVIDUAL:
			if(ad_no<16) frame(39,4,65,ad_no+5,opcode);
			else	frame(39,4,65,21,opcode);
			if (opcode==SETUP) showitem(INDIVIDUAL,0);
			break;

		 case HELP:
			frame(2,2,79,25,opcode);
			if (opcode==SETUP) showitem(HELP,0);
            break;
     default:
            break;
   }
 }

